Subject: Re: bug#54804: 29.0.50; zap-to-char: case sensitive for upper-case letter

From: Robert Pluim <[email-masked]>
Date: Wed, 11 May 2022 17:00:13 +0200

>>>>> On Wed, 11 May 2022 16:43:06 +0200, Tino Calancha <[email-masked]> said:

    Tino> Eli Zaretskii <[email-masked]> writes:
    >>> Is it the following implementation OK for such a function?
    >> 
    >> Yes, thanks.  But please call it char-uppercase-p ("upcase" has the
    >> meaning of making a character upper-case).

    Tino> I'd like to add this `char-uppercase-p'.
    Tino> Once merged, I will finish with the goal of the report.

    Tino> I appreciate a hand with the documentation part.

Youʼre *asking* us to nit-pick? Youʼre a brave person ☺️

    Tino> commit aa270a4b8813ac226a61d8e6919f68e9e4ed0973
    Tino> Author: Tino Calancha <[email-masked]>
    Tino> Date:   Wed May 11 16:34:33 2022 +0200

    Tino>     char-uppercase-p: New predicate
    
    Tino>     Return non-nil if its argument is an upper-case unicode character.
    
    Tino>     Suggested in Bug#54804.
    
    Tino>     * lisp/subr.el (char-uppercase-p): New defun.
    Tino>     * etc/NEWS (Lisp Changes in Emacs 29.1): Announce it
    Tino>     * doc/lispref/display.texi (Size of Displayed Text): Document it.
    Tino>     * test/lisp/subr-tests.el (test-char-uppercase-p): Add a test.

    Tino> diff --git a/doc/lispref/display.texi b/doc/lispref/display.texi
    Tino> index 9650d22790..1c32458d62 100644
    Tino> --- a/doc/lispref/display.texi
    Tino> +++ b/doc/lispref/display.texi
    Tino> @@ -2010,6 +2010,14 @@ Size of Displayed Text
    Tino>  (@pxref{Usual Display}).
    Tino>  @end defun
 
    Tino> +@defun char-uppercase-p char
    Tino> +This function returns non-nil if @var{char} is an uppercase unicode
    Tino> +character.  Be aware that if the Unicode tables are not yet available,
    Tino> +e.g. during bootstrap, then this function gives the right answer only
    Tino> +for @acronym{ASCII} characters; for other characters the function
    Tino> +unconditionally returns @code{nil}.
    Tino> +@end defun
    Tino> +

Be active: 'Return non-nil if ...'. So:

Return non-@code{nil} if @var{char} is an uppercase character
according to Unicode.  Be aware that if the Unicode tables are not yet
available, e.g. during bootstrap, this gives the correct answer only
for @acronym{ASCII} characters; for other characters it always returns
@code{nil}.

    Tino>  @defun string-width string &optional from to
    Tino>  This function returns the width in columns of the string @var{string},
    Tino>  if it were displayed in the current buffer and the selected window.
    Tino> diff --git a/etc/NEWS b/etc/NEWS
    Tino> index 991088a067..57c254bce8 100644
    Tino> --- a/etc/NEWS
    Tino> +++ b/etc/NEWS
    Tino> @@ -1794,6 +1794,10 @@ value.  The byte compiler will now issue a warning if it encounters
    Tino>  these forms.

    Tino> ++++
    Tino> +*** The new predicate 'char-uppercase-p' returns non-nil if its
    Tino> +argument its an uppercase unicode character.

The header line should fit on one line. So

*** New predicate 'char-uppercase-p'.
This returns...

    Tino> +
    Tino>  +++
    Tino>  *** 'restore-buffer-modified-p' can now alter buffer auto-save state.
    Tino>  With a FLAG value of 'autosaved', it will mark the buffer as having
    Tino> diff --git a/lisp/simple.el b/lisp/simple.el
    Tino> index 89fb0ea97e..525e636ab6 100644
    Tino> --- a/lisp/simple.el
    Tino> +++ b/lisp/simple.el
    Tino> @@ -6054,6 +6054,14 @@ backward-delete-char-untabify
    Tino>      ;; Avoid warning about delete-backward-char
    Tino>      (with-no-warnings (delete-backward-char n killp))))
 
    Tino> +(defun char-uppercase-p (char)
    Tino> +  "Return non-nil if CHAR is an upper-case unicode character.
    Tino> +If the Unicode tables are not yet available, e.g. during bootstrap,
    Tino> +then the function restricts to the ASCII character set."

Iʼd say 'gives correct answers only for ASCII characters'

Robert
--